<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
	<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
	<link href="stylesheet.css" rel="stylesheet" type="text/css" />
</head>
<body>
<?php


class a_file{

	public $file_name;
	public $sm_data;
	function __construct($entry) {
		$this->file_name = $entry;
		//echo "filename received: ".$this->file_name."<br />";
	}
	function get_file_name(){
		//echo "getting file name (".$this->file_name.")<br />";
		return $this->file_name;
	}
	function get_file_type(){
		$substrings = explode(".", $this->file_name);
		return $substrings[sizeof($substrings) - 1];
	}
	function is_sm(){
		if ($this->get_file_type() == "sm"){
			//parse_sm("test/".$this->file_name);
			$this->sm_data = new sm_data($this->file_name);
			 return true;
		}
		else {
			//echo "not an sm file<br />";
			return false;
		}
	}	

}

class sm_data{
	//public $sort_key;

	public $song_title;
	public $file_name;

	public $song_artist;
	public $song_subtitle;
	public $song_titletranslit;
	public $song_artisttranslit;
	public $song_subtitletranslit;
	public $bpm_min;
	public $bpm_max;

	public $single_beginner;
	public $single_easy;
	public $single_medium;
	public $single_hard;
	public $single_challenge;
	public $double_beginner;
	public $double_easy;
	public $double_medium;
	public $double_hard;
	public $double_challenge;

	private $displaybpm;
	private $displaybpm2;
	private $bpm_data;

	function __construct($entry){
		$this->file_name = $entry;
		$sections = file_get_contents($entry);
		$lines = explode(";", $sections);
		foreach ($lines as $line_num => $untrimmed_line) {
			$line = trim($untrimmed_line);
	    		
			$substrings = explode(":", $line);
				
			foreach ($substrings as &$contents){
				$contents = trim($contents); 		
				//echo htmlspecialchars($contents)."<br />";
			}
			
			if ($substrings[0] == "#TITLE" || $substrings[0] == "﻿#TITLE") $this->song_title = $substrings[1];
			if ($substrings[0] == "#TITLETRANSLIT") $this->song_titletranslit = $substrings[1];
			
			//if (!is_null($this->song_titletranslit)) $this->sort_key = $this->song_titletranslit;
			//else $this->sort_key = $this->song_title;

			if ($substrings[0] == "#SUBTITLE") $this->song_subtitle = $substrings[1];
			if ($substrings[0] == "#SUBTITLETRANSLIT") $this->song_subtitletranslit = $substrings[1];

			if ($substrings[0] == "#ARTIST") $this->song_artist = $substrings[1];
			if ($substrings[0] == "#ARTISTTRANSLIT") $this->song_artisttranslit = $substrings[1];

			if ($substrings[0] == "#DISPLAYBPM"){ 
				$this->displaybpm = $substrings[1];	
				 $this->displaybpm2 = $substrings[2];	
			}
			if ($substrings[0] == "#BPMS") $this->get_bpm_range($substrings[1]);

			

			if (strstr($substrings[0], "#NOTES")){
				if ($substrings[1] == "dance-single"){
					if ($substrings[3] == "Beginner") $this->single_beginner = $substrings[4];			
					if ($substrings[3] == "Easy") $this->single_easy = $substrings[4];			
					if ($substrings[3] == "Medium") $this->single_medium = $substrings[4];			
					if ($substrings[3] == "Hard") $this->single_hard = $substrings[4];			
					if ($substrings[3] == "Challenge") $this->single_challenge = $substrings[4];			

				}	
				else if  ($substrings[1] == "dance-double"){
					if ($substrings[3] == "Beginner") $this->double_beginner = $substrings[4];			
					if ($substrings[3] == "Easy") $this->double_easy = $substrings[4];			
					if ($substrings[3] == "Medium") $this->double_medium = $substrings[4];			
					if ($substrings[3] == "Hard") $this->double_hard = $substrings[4];			
					if ($substrings[3] == "Challenge") $this->double_challenge = $substrings[4];			

				}

				
	
				//if ($substrings[3] == "Beginner") echo "Beginner ";
				//else if ($substrings[3] == "Easy") echo "Light ";
				//else if ($substrings[3] == "Medium") echo "Standard ";
				//else if ($substrings[3] == "Hard") echo "Heavy ";
				//else if ($substrings[3] == "Challenge") echo "Challenge ";
				//echo $substrings[4]."<br />";

			}

		}
	
	}

	function get_bpm_range($bpm_data){
		//echo $bpm_data."<br />";
		
		if (!is_null($this->displaybpm)){
			//echo $this->displaybpm."<br />";
			//$temp = explode("=", $this->displaybpm);
			$this->bpm_min = round($this->displaybpm, 0);	
			if (!is_null($this->displaybpm2)){
				$this->bpm_max = round($this->displaybpm2, 0);
			}	
			else $this->bpm_max = round($this->displaybpm, 0);	

			//echo $this->bpm_min."-".$this->bpm_max."<br />";
		}
		else
		{
			$bpm_data1 = explode(",", $bpm_data);
			foreach ($bpm_data1 as $bpm_data2){
				//echo $bpm_data2."<br />";
				$bpms = explode("=", $bpm_data2);
				foreach ($bpms as $testtest){ 
					$bpms2[] = round($bpms[1], 0);
					$this->bpm_min = min($bpms2);
					$this->bpm_max = max($bpms2);
					
				}
			}
		}
		//echo $this->bpm_min."-".$this->bpm_max."<br />";
	}
	function show_bpm_range(){
		echo $this->bpm_min;
		if ($this->bpm_min != $this->bpm_max) echo "-".$this->bpm_max;

	}

	function display_song_info(){
		echo $this->song_title."<br />";
		echo $this->song_artist."<br />";
		echo $this->song_subtitle."<br />";
		echo $this->song_titletranslit."<br />";
		echo $this->song_artisttranslit."<br />";
		$this->show_bpm_range();
		echo "<br />";
		echo $this->song_subtitletranslit."<br />";
		echo "single ";
		echo $this->single_beginner."|";
		echo $this->single_easy."|";
		echo $this->single_medium."|";
		echo $this->single_hard."|";
		echo $this->single_challenge."<br />";
		echo "double ";
		echo $this->double_beginner."|";
		echo $this->double_easy."|";
		echo $this->double_medium."|";
		echo $this->double_hard."|";
		echo $this->double_challenge."<br />";
		echo "<br />";
	}

	function stepchart_gen_link($file, $style, $difficulty, $foot_rating){
		echo "<a href=\"smsend.php?sm=".htmlentities($file)."&style=".$style."&difficulty=".$difficulty."\" target=\"blank\">";
		echo $foot_rating;
		echo "</a>";

		//echo "<form name=\"smform".$file $style $difficulty."\" action=\"smsend.php\" method=\"post\">";
		//echo "<input name=\"sm\" value=\"".$file."\" type=\"hidden\" />";
		//echo "<input type=\"text\" name="user" />
		//echo "</form>";
		
	}

	function display_song_info_table(){
		echo "<td>";
		echo $this->song_title." ".$this->song_subtitle;
		if (!is_null($this->song_titletranslit)) 
			echo "<br /><i>".$this->song_titletranslit." ".$this->song_subtitletranslit."</i>";
		echo "</td>";
		echo "<td>";
		echo $this->song_artist;
		if (!is_null($this->song_artisttranslit)) 
			echo "<br /><i>".$this->song_artisttranslit."</i>";

		echo "</td>";
		echo "<td>";
		$this->show_bpm_range();
		echo "</td>";
		echo "<td class=\"beginner\">";
		$this->stepchart_gen_link($this->file_name, "dance-single", "beginner", $this->single_beginner);
		echo "</td>";
		echo "<td class=\"easy\">";
		$this->stepchart_gen_link($this->file_name, "dance-single", "easy", $this->single_easy);

		echo "</td>";
		echo "<td class=\"medium\">";
		$this->stepchart_gen_link($this->file_name, "dance-single", "medium", $this->single_medium);
		echo "</td>";
		echo "<td class=\"hard\">";
		$this->stepchart_gen_link($this->file_name, "dance-single", "hard", $this->single_hard);
		echo "</td>";
		echo "<td class=\"challenge\">";
		$this->stepchart_gen_link($this->file_name, "dance-single", "challenge", $this->single_challenge);
		echo "</td>";
		echo "<td class=\"beginner\">";
		$this->stepchart_gen_link($this->file_name, "dance-double", "beginner", $this->double_beginner);
		echo "</td>";
		echo "<td class=\"easy\">";
		$this->stepchart_gen_link($this->file_name, "dance-double", "easy", $this->double_easy);

		echo "</td>";
		echo "<td class=\"medium\">";
		$this->stepchart_gen_link($this->file_name, "dance-double", "medium", $this->double_medium);
		echo "</td>";
		echo "<td class=\"hard\">";
		$this->stepchart_gen_link($this->file_name, "dance-double", "hard", $this->double_hard);
		echo "</td>";
		echo "<td class=\"challenge\">";
		$this->stepchart_gen_link($this->file_name, "dance-double", "challenge", $this->double_challenge);
		echo "</td>";
	}
}

function parse_sm($sm_file){
	$sections = file_get_contents($sm_file);
	$lines = explode(";", $sections);
	foreach ($lines as $line_num => $untrimmed_line) {
		$line = trim($untrimmed_line);
    		
		$substrings = explode(":", $line);
			
		foreach ($substrings as &$contents){
			$contents = trim($contents); 		
			//echo htmlspecialchars($contents)."<br />";
		}
		
		if ($substrings[0] == "#TITLE") echo "Song: ".$substrings[1]."<br />";

		if ($substrings[0] == "#SUBTITLE") echo "Subtitle: ".$substrings[1]."<br />";
		if ($substrings[0] == "#ARTIST") echo "Artist: ".$substrings[1]."<br />";

		if (strstr($substrings[0], "#NOTES")){
			if ($substrings[1] == "dance-single") echo "Single ";
			else if  ($substrings[1] == "dance-double") echo "Double ";

			if ($substrings[3] == "Beginner") echo "Beginner ";
			else if ($substrings[3] == "Easy") echo "Light ";
			else if ($substrings[3] == "Medium") echo "Standard ";
			else if ($substrings[3] == "Hard") echo "Heavy ";
			else if ($substrings[3] == "Challenge") echo "Challenge ";
			echo $substrings[4]."<br />";




		}

		
	}

}


$d = dir("./");

while (false !== ($entry = $d->read())) {
	$file_array[] = new a_file($entry);
	$num_files += 1;
	//echo get_file_type($entry)."<br />";
}
$d->close();


foreach($file_array as $i => $moo){
	//echo $moo->file_name;
//	echo $moo->get_file_name();
//	echo $moo->get_file_type();
	if ($moo->is_sm()){
//		 echo "is an sm file<br />";
		$sm_array[] = $moo->sm_data;
	}
//	else echo "is not an sm file<br />";
//	if ($moo->get_file_type() == "jpg" || $moo->get_file_type() == "png") echo "<img src=\"test/".$moo->get_file_name()."\" />";
	
//	echo $moo->sm_data->song_title;



	//echo "test";
}
sort($sm_array);




foreach ($sm_array as $bleh){
	
	if (!is_null($bleh->single_beginner)) $num_single_beginner += 1;
	if (!is_null($bleh->single_easy)) $num_single_easy+= 1;
	if (!is_null($bleh->single_medium)) $num_single_medium += 1;
	if (!is_null($bleh->single_hard)) $num_single_hard += 1;
	if (!is_null($bleh->single_challenge)) $num_single_challenge+= 1;
	if (!is_null($bleh->double_beginner)) $num_double_beginner += 1;
	if (!is_null($bleh->double_easy)) $num_double_easy+= 1;
	if (!is_null($bleh->double_medium)) $num_double_medium += 1;
	if (!is_null($bleh->double_hard)) $num_double_hard += 1;
	if (!is_null($bleh->double_challenge)) $num_double_challenge += 1;


}



echo "There are " . sizeof($sm_array) . " songs in this collection<br />";
echo "<p>";
if ($num_single_beginner != 0) echo $num_single_beginner." Single Novice<br />";
if ($num_single_easy!= 0) echo $num_single_easy." Single Easy<br />";
if ($num_single_medium!= 0) echo $num_single_medium." Single Medium<br />";
if ($num_single_hard!= 0) echo $num_single_hard." Single Hard<br />";
if ($num_single_challenge!= 0) echo $num_single_challenge." Single Expert<br />";
if ($num_double_beginner != 0) echo $num_double_beginner." Double Novice<br />";
if ($num_double_easy!= 0) echo $num_double_easy." Double Easy<br />";
if ($num_double_medium!= 0) echo $num_double_medium." Double Medium<br />";
if ($num_double_hard!= 0) echo $num_double_hard." Double Hard<br />";
if ($num_double_challenge!= 0) echo $num_double_challenge." Double Expert<br />";
echo "</p>";

echo "<table>";
echo "<tr>";
echo "<td rowspan=\"2\">Song</td>";
echo "<td rowspan=\"2\">Artist</td>";
echo "<td rowspan=\"2\">BPM</td>";
echo "<td colspan=\"5\">Single</td>";
echo "<td colspan=\"5\">Double</td>";

echo "</tr>";
echo "<tr>";
echo "<td>Nov</td>";
echo "<td>Esy</td>";
echo "<td>Med</td>";
echo "<td>Hrd</td>";
echo "<td>Exp</td>";
echo "<td>Nov</td>";
echo "<td>Esy</td>";
echo "<td>Med</td>";
echo "<td>Hrd</td>";
echo "<td>Exp</td>";
echo "</tr>";

	foreach ($sm_array as $bleh){
		echo "<tr>";

		//echo $bleh->song_title;
		$bleh->display_song_info_table();

		echo "</tr>";
	}
echo "</table>";


/*
foreach ($sm_array as $bleh){
	//echo $bleh->song_title;
	$bleh->display_song_info();
}
*/

?>
</body>
</html>
